{ open Parser }
let letter =['a'-'z' 'A'-'Z']
let digit = ['0'-'9']

rule token = parse
  [' ' '\t' '\r' '\n'] 			{token lexbuf}
| '='     { ASSIGN}
| '+' 		{ PLUS }
| '-' 	  { MINUS}
| '*'     { TIMES}
| '/'     { DIVIDE}
| ".+"    { DADD}
| ".-"    { DSUB}
| ".*"    { DMULT}
| "./"    { DDIV}
| "&&"    { AND }
| "||"    { OR}
| "=="    { EQ }
| "!="    { NEQ }
| ">"     { GT }
| "<"     { LT }
| ">="    { GEQ }
| "<="    { LEQ }
| '('     { LPAREN }
| ')'     { RPAREN }
| '['     { LBRACKET}                    
| ']'     { RBRACKET}
| '{'     { LBRACE}
| '}'     { RBRACE}
| ';'     { SEMI}
| ','     { COMMA}
| '%'	    { PERCENT}
| '\"'[^'\"']*'\"' as lxm { STRING(lxm) }     
| "if"    { IF}
| "while" { WHILE}
| "else"  { ELSE}
| "int"   { INT }
| "Creatarray"{CREATEARRAY}
| "string"      {STR}
| "intarray" {INTARRAY}
(*| "strarray" {STRARRAY} *)
| "def"   			{DEF}
| "return"      {RETURN}
| letter(letter|digit|'_')* as id {ID(id)}
| digit+ as lit  {INTEGER(int_of_string lit)}
| "#~"           {comment lexbuf}
| eof            {EOF}
| _ as invaildchar  {raise (Failure("illegal character "^ Char.escaped invaildchar))} 
and comment = 
	parse "~#" {token   lexbuf}
	      |_   {comment lexbuf}

			